<script setup lang="ts">
import { computed, onMounted, ref } from 'vue'
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import { useBranchStore } from '@/stores/branch'
import { usePermissionStore } from '@/stores/permission'
import { useAuthStore } from '@/stores/auth'
import { usereprotReceiptStore } from '@/stores/reportreceipt'
import { useDashBoradStore } from '@/stores/dashboard'
import { useStockStore } from '@/stores/stock'
import { Bar } from 'vue-chartjs'
import StaffSales from './ReportSales/StaffSales.vue'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'
import type { Stock } from '@/types/Stock'
ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

const headersOwner = [
  {
    key: 'id',
    sortable: false,
    title: 'ProuductId'
  },
  { key: 'name', title: 'ProuductName' },
  { key: 'minimum', title: 'Minimum' },
  { key: 'balance', title: 'Balance' },
  { key: 'unit', title: 'Unit' },
  { key: 'price', title: 'Price' },
  { key: 'branch', title: 'Branch', value: (item: any | Stock) => item.branch?.name }
]

const permissionStore = usePermissionStore()
const branchStore = useBranchStore()
const reprotReceiptStore = usereprotReceiptStore()
const authStore = useAuthStore()
const dashBoardStore = useDashBoradStore()
const stockStore = useStockStore()

const t = ref(0)
const labelss = ref<string[]>([])
const dataValues = ref<number[]>([])
const icons = ['mdi-facebook', 'mdi-twitter', 'mdi-linkedin', 'mdi-instagram']
const datePicker = new Date().getFullYear()
const selectedYear = ref(new Date().getFullYear())

const chartOptions = {
  scales: {
    x: {
      title: {
        display: true,
        text: datePicker.toString()
      }
    },
    y: {
      title: {
        display: true,
        text: 'Sales Value'
      }
    }
  }
}

function dialog() {
  dashBoardStore.dialogLowStock = true
}

async function setYearly() {
  t.value = 0
  labelss.value = []
  dataValues.value = []
  console.log('Year ' + datePicker)
  await reprotReceiptStore.reportYear(datePicker.toString())

  labelss.value = reprotReceiptStore.data.map((item: any) => {
    const monthNames = [
      'Jan',
      'Feb',
      'Mar',
      'Apr',
      'May',
      'Jun',
      'Jul',
      'Aug',
      'Sep',
      'Oct',
      'Nov',
      'Dec'
    ]
    return monthNames[item.month - 1]
  })

  dataValues.value = reprotReceiptStore.data.map((item: any) => {
    return item.total_month
  })
  console.log('dataValues ' + dataValues.value)
}

async function setYearlyBranch() {
  t.value = 0
  labelss.value = []
  dataValues.value = []
  await reprotReceiptStore.reportYearBranch(authStore.getCurrentUser()?.branch?.id!)

  labelss.value = reprotReceiptStore.data.map((item: any) => {
    const monthNames = [
      'Jan',
      'Feb',
      'Mar',
      'Apr',
      'May',
      'Jun',
      'Jul',
      'Aug',
      'Sep',
      'Oct',
      'Nov',
      'Dec'
    ]
    return monthNames[item.month - 1]
  })

  dataValues.value = reprotReceiptStore.data.map((item: any) => {
    return item.total_month
  })
  console.log('dataValues ' + dataValues.value)
}

function getProfitColor(profit: number) {
  return profit < 0 ? 'rgb(178,34,34)' : 'rgb(34,139,34)'
} //red           //green

const chartData = computed(() => ({
  labels: labelss.value,
  datasets: [
    {
      label: 'Sales Growth',
      data: dataValues.value,
      backgroundColor: 'rgba(229, 72, 0)',
      borderWidth: 1
    }
  ]
}))

onMounted(async () => {
  if (!permissionStore.isEmp()) {
    permissionStore.pushMember()
  } else if (authStore.getCurrentUser()?.role === 'Owner') {
    dashBoardStore.refresh()
    dashBoardStore.calTotal()
    setYearly()
  } else if (authStore.getCurrentUser()?.role === 'Manager') {
    dashBoardStore.refresh()
    dashBoardStore.calTotalBranch()
    setYearlyBranch()
  }
  await stockStore.getStocks()
  stockStore.minimumStock()
  await branchStore.getBranchs()
})
</script>

<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <v-carousel cover cycle show-arrows="hover" hide-delimiter-background height="600">
    <v-carousel-item cover src="\src\assets\mainmenu\banner.png"
      >\
      <div style="margin-left: 790px; margin-top: 60px">
        <v-img :width="250" src="\src\assets\mainmenu\logo1.png"></v-img>
      </div>
      <div class="fill-height text-white" style="padding: 20px; display: flex; flex-wrap: wrap">
        <div style="margin-left: 580px">
          <h4 style="font-size: 100px">COFFEE SHOP</h4>
          <p class="subheading" style="margin-top: 20px; font-size: 15px; margin-left: 220px">
            Welcome to coffee shop website
          </p>
        </div>
      </div>
    </v-carousel-item>
    <v-carousel-item cover src="\src\assets\mainmenu\banner3.gif">
      <div style="margin-left: 800px; margin-top: 90px">
        <v-img :width="250" src="\src\assets\mainmenu\logo2.png"></v-img>
      </div>
      <div class="fill-height text-white" style="padding: 20px; display: flex; flex-wrap: wrap">
        <div style="margin-left: 660px">
          <h4 style="font-size: 100px">Point of Sell</h4>
          <p class="subheading" style="margin-top: 20px; font-size: 15px; margin-left: 70px">
            You can manage your orders for cash products on this page.
          </p>
        </div>
      </div>
    </v-carousel-item>
    <v-carousel-item cycle src="\src\assets\mainmenu\banner2.png" cover>
      <div style="margin-left: 790px; margin-top: 90px">
        <v-img :width="250" src="\src\assets\mainmenu\logo3.png"></v-img>
      </div>
      <div class="fill-height text-white" style="padding: 20px; display: flex; flex-wrap: wrap">
        <div style="margin-left: 730px">
          <h4 style="font-size: 100px; margin-left: 20px">Member</h4>
          <p class="subheading" style="margin-top: 20px; font-size: 15px; margin-left: 0px">
            Our store offers member discounts and special monthly promotions.
          </p>
        </div>
      </div>
    </v-carousel-item>
    <v-carousel-item cycle src="\src\assets\mainmenu\banner4.png" cover>
      <div style="margin-left: 785px; margin-top: 90px">
        <v-img :width="250" src="\src\assets\mainmenu\logo1.png"></v-img>
      </div>
      <div class="fill-height text-white" style="padding: 20px; display: flex; flex-wrap: wrap">
        <div style="margin-left: 750px">
          <h4 style="font-size: 100px">Product</h4>
          <p class="subheading" style="margin-top: 20px; font-size: 15px; margin-left: 0px">
            Our products are well-crafted, affordable and delicious.
          </p>
        </div>
      </div>
    </v-carousel-item>
    <v-carousel-item cycle src="\src\assets\mainmenu\banner5.png" cover>
      <div style="margin-left: 800px; margin-top: 90px">
        <v-img :width="250" src="\src\assets\mainmenu\logo2.png"></v-img>
      </div>
      <div class="fill-height text-white" style="padding: 20px; display: flex; flex-wrap: wrap">
        <div style="margin-left: 550px">
          <h4 style="font-size: 100px">Stock Management</h4>
          <p class="subheading" style="margin-top: 20px; font-size: 15px; margin-left: 220px">
            Our shop imports raw materials from overseas
          </p>
          <p class="subheading" style="margin-top: 0px; font-size: 15px; margin-left: 250px">
            have very good quality and standards.
          </p>
        </div>
      </div>
    </v-carousel-item>
  </v-carousel>
  <div style="background-color: #eae7de">
    <br /><br /><br /><br />
    <h4 align="center" style="font-size: 100px">Dashboard</h4>
    <h4 align="center" style="font-size: 20px; color: #b89769">
      _______________________________________________
    </h4>
    <v-container v-if="authStore.getCurrentUser()?.role === 'Owner'">
      <v-row>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px; margin-left: 40px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            :color="getProfitColor(dashBoardStore.profit)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Profit {{ dashBoardStore.profit }} ฿</v-sheet
          >
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="rgb(34,139,34)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Income Value {{ dashBoardStore.incomeValue }} ฿</v-sheet
          >
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="rgb(178,34,34)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Cost Value
            {{ dashBoardStore.billtotal + dashBoardStore.orderStock + dashBoardStore.salaryValue }}
            ฿
          </v-sheet>
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="grey-darken-3"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            @click="dialog()"
            >Low Stock
            {{ stockStore.stockLows.length }}
          </v-sheet>
        </v-col></v-row
      >
      <v-row
        ><v-col cols="12" sm="12" md="2"><br /></v-col
      ></v-row>
      <v-row>
        <v-col cols="12" sm="12" md="2"> </v-col>
        <v-col cols="12" sm="12" md="8"><Bar :data="chartData" :options="chartOptions" /></v-col>
        <v-col cols="12" sm="12" md="2"> </v-col>
      </v-row>
    </v-container>
    <v-container v-if="authStore.getCurrentUser()?.role === 'Manager'">
      <v-row>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px; margin-left: 40px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            :color="getProfitColor(dashBoardStore.profit)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Profit {{ dashBoardStore.profit }} ฿</v-sheet
          >
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="rgb(34,139,34)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Income Value {{ dashBoardStore.incomeValue }} ฿</v-sheet
          >
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="2" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="rgb(178,34,34)"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            >Cost Value
            {{ dashBoardStore.billtotal + dashBoardStore.orderStock + dashBoardStore.salaryValue }}
            ฿
          </v-sheet>
        </v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"></v-col>
        <v-col cols="12" sm="12" md="1" style="padding-top: 20px"
          ><v-sheet
            min-width="250"
            max-width="400"
            height="150"
            elevation="4"
            class="list-item-hover"
            color="grey-darken-3"
            style="font-size: 24px; display: flex; justify-content: center; align-items: center"
            @click="dialog()"
            >Low Stock
            {{ stockStore.stockLows.length }}
          </v-sheet>
        </v-col></v-row
      >
      <v-row
        ><v-col cols="12" sm="12" md="2"><br /></v-col
      ></v-row>
      <v-row>
        <v-col cols="12" sm="12" md="2"> </v-col>
        <v-col cols="12" sm="12" md="8"><Bar :data="chartData" :options="chartOptions" /></v-col>
        <v-col cols="12" sm="12" md="2"> </v-col>
      </v-row>
    </v-container>
    <v-container v-if="authStore.getCurrentUser()?.role === 'Staff'">
      <StaffSales></StaffSales>
    </v-container>
  </div>
  <v-footer class="bg-grey-darken-4 text-center d-flex flex-column">
    <div>
      <v-btn v-for="icon in icons" :key="icon" class="mx-4" :icon="icon" variant="text"></v-btn>
    </div>
  </v-footer>

  <v-dialog v-model="dashBoardStore.dialogLowStock" persistent width="1024" style="z-index: 1">
    <v-container style="background-color: #eae7de">
      <v-card-title>
        <span class="text-h5">Low Stock</span>
      </v-card-title>
      <v-container>
        <v-row>
          <v-data-table
            :headers="headersOwner"
            :items="stockStore.stockLows"
            style="background-color: #eae7de"
          >
            <template v-slot:top> </template> </v-data-table
        ></v-row>
      </v-container>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="dashBoardStore.closeLowStock()">
          Close
        </v-btn>
      </v-card-actions>
    </v-container>
  </v-dialog>
</template>

<style scoped>
.fixed-bottom {
  position: absolute;
  bottom: 0;
  left: 50%;
  transform: translateX(-50%);
}
.v-card {
  transition: opacity 0.4s ease-in-out;
}

.v-card:not(.on-hover) {
  opacity: 0.6;
}

.show-btns {
  color: rgba(255, 255, 255, 1) !important;
}

.list-item-hover {
  transition:
    transform 0.2s ease,
    box-shadow 0.2s ease; /* Add transitions for smoother animation */
}

.list-item-hover:hover {
  transform: scale(1.05); /* Increase size by 5% on hover */
  box-shadow:
    0 4px 6px rgba(0, 0, 0, 0.1),
    0 1px 3px rgba(0, 0, 0, 0.08); /* Add a subtle box shadow */
}
</style>
